#include "Bureaucrat.hpp"
#include <iostream>

int	main() {

	std::cout << "-------------Bureaucrat TEST-----------" << std::endl;
	std::cout << "Constructor too high grade" << std::endl;
	{
		try {
			Bureaucrat crat("crat", 0);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;

	std::cout << "Constructor too low grade" << std::endl;
	{
		try {
			Bureaucrat crat("crat", 151);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "increment too high" << std::endl;
	{
		Bureaucrat crat("crat", 1);
		try {
			crat.increment();
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "decrement too low" << std::endl;
	{
		Bureaucrat crat("crat", 150);
		try {
			crat.decrement();
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;

	std::cout << "setgrade too low" << std::endl;
	{
		Bureaucrat crat("crat", 42);
		try {
			crat.setGrade(151);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "setgrade too high" << std::endl;
	{
		Bureaucrat crat("crat", 42);
		try {
			crat.setGrade(0);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "increment normal" << std::endl;
	{
		Bureaucrat crat("crat", 42);
		std::cout << "default grade: " << crat.getGrade() << std::endl;
		crat.increment();
		std::cout << "after increment grade: " << crat.getGrade() << std::endl;
	}
	std::cout << std::endl;

	std::cout << "decrement normal" << std::endl;
	{
		Bureaucrat crat("crat", 42);
		std::cout << "default grade: " << crat.getGrade() << std::endl;
		crat.decrement();
		std::cout << "after decrement grade: " << crat.getGrade() << std::endl;
	}
	std::cout << std::endl;

	std::cout << "print" << std::endl;
	{
		Bureaucrat crat("crat", 42);
		std::cout << crat;
	}
	std::cout << std::endl;

	std::cout << "------------- Form TEST-----------" << std::endl;

	std::cout << "Constructor too high sign grade" << std::endl;
	{
		try {
			Form("form", 42, 0);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;

	std::cout << "Constructor too low sign grade" << std::endl;
	{
		try {
			Form("form", 42, 151);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;

	std::cout << "Constructor too high exec grade" << std::endl;
	{
		try {
			Form("form", 0, 42);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;

	std::cout << "Constructor too low exec grade" << std::endl;
	{
		try {
			Form("form", 151, 42);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "print" << std::endl;
	{
		Form form("form", 42, 42);
		std::cout << form;
	}
	std::cout << std::endl;
	
	std::cout << "------------- Form Sign TEST-----------" << std::endl;

	std::cout << "Bureaucrat sign a Form" << std::endl;
	{
		Form form("form", 42, 42);
		Bureaucrat crat("crat", 42);

		crat.signForm(form);
	}
	std::cout << std::endl;

	std::cout << "Too low Bureaucrat sign a Form" << std::endl;
	{
		Form form("form", 42, 1);
		Bureaucrat crat("crat", 42);
		try	{
			crat.signForm(form);
		} catch (std::exception &e) {
			std::cout << e.what() << std::endl;
		}
	}
	std::cout << std::endl;
	
	std::cout << "High Bureaucrat sign a low Form" << std::endl;
	{
		Form form("form", 42, 150);
		Bureaucrat crat("crat", 1);
	
		crat.signForm(form);
	}
	std::cout << std::endl;

	std::cout << "Form already sign" << std::endl;
	{
		Form form("form", 42, 150);
		Bureaucrat crat("crat", 1);
	
		crat.signForm(form);
		crat.signForm(form);
	}
	std::cout << std::endl;
}
